## stella 3.9.3

=== Makefile ===
##============================================================================
##
##   SSSS    tt          lll  lll
##  SS  SS   tt           ll   ll
##  SS     tttttt  eeee   ll   ll   aaaa
##   SSSS    tt   ee  ee  ll   ll      aa
##      SS   tt   eeeeee  ll   ll   aaaaa  --  "An Atari 2600 VCS Emulator"
##  SS  SS   tt   ee      ll   ll  aa  aa
##   SSSS     ttt  eeeee llll llll  aaaaa
##
## Copyright (c) 1995-2014 by Bradford W. Mott, Stephen Anthony
## and the Stella Team
##
## See the file "License.txt" for information on usage and redistribution of
## this file, and for a DISCLAIMER OF ALL WARRANTIES.
##
## $Id: Makefile,v 1.37 2009-01-11 21:31:21 stephena Exp $
##
##   Based on code from ScummVM - Scumm Interpreter
##   Copyright (C) 2002-2004 The ScummVM project
##============================================================================

#######################################################################
# Default compilation parameters. Normally don't edit these           #
#######################################################################

srcdir      ?= .

DEFINES     :=
LDFLAGS     :=
INCLUDES    :=
LIBS	    :=
OBJS	    :=
PROF        :=

MODULES     :=
MODULE_DIRS :=

DISTNAME    := stella-snapshot

# Load the make rules generated by configure
include config.mak

# Uncomment this for stricter compile time code verification
# CXXFLAGS+= -Werror

ifdef CXXFLAGS
  CXXFLAGS:= $(CXXFLAGS)
else
  CXXFLAGS:= -O2
endif
CXXFLAGS+= -Wall 
ifdef HAVE_GCC
  CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual
endif

ifdef PROFILE
  PROF:= -g -pg -fprofile-arcs -ftest-coverage
  CXXFLAGS+= $(PROF)
else
  ifdef HAVE_GCC
    CXXFLAGS+= -fomit-frame-pointer
  endif
endif

# Even more warnings...
#CXXFLAGS+= -pedantic -Wpointer-arith -Wcast-qual -Wconversion
#CXXFLAGS+= -Wshadow -Wimplicit -Wundef -Wnon-virtual-dtor
#CXXFLAGS+= -Wno-reorder -Wwrite-strings -fcheck-new -Wctor-dtor-privacy 

#######################################################################
# Misc stuff - you should never have to edit this                     #
#######################################################################

EXECUTABLE  := stella$(EXEEXT)

all: $(EXECUTABLE)


######################################################################
# Various minor settings
######################################################################

# The name for the directory used for dependency tracking
DEPDIR := .deps


######################################################################
# Module settings
######################################################################

MODULES := $(MODULES)

# After the game specific modules follow the shared modules
MODULES += \
	src/emucore \
	src/gui \
	src/common \
	src/common/tv_filters

######################################################################
# The build rules follow - normally you should have no need to
# touch whatever comes after here.
######################################################################

# Concat DEFINES and INCLUDES to form the CPPFLAGS
CPPFLAGS:= $(DEFINES) $(INCLUDES)

# Include the build instructions for all modules
-include $(addprefix $(srcdir)/, $(addsuffix /module.mk,$(MODULES)))

# Depdir information
DEPDIRS = $(addsuffix /$(DEPDIR),$(MODULE_DIRS))
DEPFILES = 

# The build rule for the Stella executable
$(EXECUTABLE):  $(OBJS)
	$(LD) $(LDFLAGS) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) $(PROF) -o $@

distclean: clean
	$(RM_REC) $(DEPDIRS)
	$(RM) build.rules config.h config.mak config.log

clean:
	$(RM) $(OBJS) $(EXECUTABLE)

.PHONY: all clean dist distclean

.SUFFIXES: .cxx


ifndef CXX_UPDATE_DEP_FLAG
# If you use GCC, disable the above and enable this for intelligent
# dependency tracking. 
CXX_UPDATE_DEP_FLAG = -Wp,-MMD,"$(*D)/$(DEPDIR)/$(*F).d2"
.cxx.o:
	$(MKDIR) $(*D)/$(DEPDIR)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
	$(ECHO) "$(*D)/" > $(*D)/$(DEPDIR)/$(*F).d
	$(CAT) "$(*D)/$(DEPDIR)/$(*F).d2" >> "$(*D)/$(DEPDIR)/$(*F).d"
	$(RM) "$(*D)/$(DEPDIR)/$(*F).d2"

.c.o:
	$(MKDIR) $(*D)/$(DEPDIR)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
	$(ECHO) "$(*D)/" > $(*D)/$(DEPDIR)/$(*F).d
	$(CAT) "$(*D)/$(DEPDIR)/$(*F).d2" >> "$(*D)/$(DEPDIR)/$(*F).d"
	$(RM) "$(*D)/$(DEPDIR)/$(*F).d2"
else
# If you even have GCC 3.x, you can use this build rule, which is safer; the above
# rule can get you into a bad state if you Ctrl-C at the wrong moment.
# Also, with this GCC inserts additional dummy rules for the involved headers,
# which ensures a smooth compilation even if said headers become obsolete.
.cxx.o:
	$(MKDIR) $(*D)/$(DEPDIR)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o

.c.o:
	$(MKDIR) $(*D)/$(DEPDIR)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
endif

# Include the dependency tracking files. We add /dev/null at the end
# of the list to avoid a warning/error if no .d file exist
-include $(wildcard $(addsuffix /*.d,$(DEPDIRS))) /dev/null

# check if configure has been run or has been changed since last run
config.mak: $(srcdir)/configure
	@echo "You need to run ./configure before you can run make"
	@echo "Either you haven't run it before or it has changed."
	@exit 1

install: all
	$(INSTALL) -d "$(DESTDIR)$(BINDIR)"
	$(INSTALL) -c -s -m 755 "$(srcdir)/stella$(EXEEXT)" "$(DESTDIR)$(BINDIR)/stella$(EXEEXT)"
	$(INSTALL) -d "$(DESTDIR)$(DOCDIR)"
	$(INSTALL) -c -m 644 "$(srcdir)/Announce.txt" "$(srcdir)/Changes.txt" "$(srcdir)/Copyright.txt" "$(srcdir)/License.txt" "$(srcdir)/README-SDL.txt" "$(srcdir)/Readme.txt" "$(srcdir)/Todo.txt" "$(srcdir)/docs/index.html" "$(srcdir)/docs/debugger.html" "$(DESTDIR)$(DOCDIR)/"
	$(INSTALL) -d "$(DESTDIR)$(DOCDIR)/graphics"
	$(INSTALL) -c -m 644 $(wildcard $(srcdir)/docs/graphics/*.png) "$(DESTDIR)$(DOCDIR)/graphics"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/applications"
	$(INSTALL) -c -m 644 "$(srcdir)/src/unix/stella.desktop" "$(DESTDIR)$(DATADIR)/applications"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/16x16/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/22x22/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/24x24/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/32x32/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/48x48/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/64x64/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-16x16.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/16x16/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-22x22.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/22x22/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-24x24.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/24x24/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-32x32.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/32x32/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-48x48.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/48x48/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-64x64.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/64x64/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-128x128.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps/stella.png"

install-strip: install
	$(STRIP) stella$(EXEEXT)

uninstall:
	rm -f  "$(DESTDIR)$(BINDIR)/stella$(EXEEXT)"
	rm -rf "$(DESTDIR)$(DOCDIR)/"
	rm -f  "$(DESTDIR)$(DATADIR)/applications/stella.desktop"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/16x16/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/22x22/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/24x24/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/32x32/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/48x48/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/64x64/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps/stella.png"

# Special rule for M6502.ins, generated from m4 (there's probably a better way to do this ...)
src/emucore/M6502.ins: src/emucore/M6502.m4
	m4 src/emucore/M6502.m4 > src/emucore/M6502.ins

# Special rule for Win32 icon stuff (there's probably a better way to do this ...)
src/win32/stella_icon.o: src/win32/stella.ico src/win32/stella.rc
	$(WINDRES) --include-dir src/win32 src/win32/stella.rc src/win32/stella_icon.o 
		
.PHONY: deb bundle test install uninstall

=== debian/changelog ===
stella (3.9.3-1) unstable; urgency=medium

  * New upstream version.
  * Standards-Version 3.9.5, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 26 Jan 2014 23:42:21 +0100

stella (3.9.2-1) unstable; urgency=low

  * New upstream version.

 -- Stephen Kitt <skitt@debian.org>  Sun, 08 Sep 2013 00:09:17 +0200

stella (3.9.1-1) unstable; urgency=low

  * New upstream version. The state file format has changed, so old state
    files will not work with this release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 21 Aug 2013 22:39:42 +0200

=== debian/control ===
Source: stella
Section: otherosfs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen Kitt <skitt@debian.org>
Standards-Version: 3.9.5
Build-Depends: autotools-dev,
               debhelper (>= 9),
               libpng-dev,
               libsdl1.2-dev,
               zlib1g-dev
Homepage: http://stella.sf.net
Vcs-Git: git://anonscm.debian.org/pkg-games/stella.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/stella.git

Package: stella
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Atari 2600 Emulator for SDL & the X Window System
 Stella is a portable emulator of the old Atari 2600 video-game
 console. You can play most Atari 2600 games with it.
 .
 Stella's features include:
  * emulation of Atari 2600 joysticks, keyboards, paddles and driving
    controllers using the host system's input peripherals;
  * emulation of trackballs, joysticks, booster grips, driving
    controllers and the Amiga Mouse using the host system's mouse;
  * support for real Atari 2600 controllers using the Stelladaptor,
    2600-daptor or 2600-daptor II;
  * support for real Atari 7800 controllers using the 2600-daptor II;
  * support for the speech portion of a real AtariVox device;
  * support for Supercharger single-load and multi-load games;
  * emulation of CRT TV features, including texturing, colour bleed,
    RF noise and phosphor burn-off (requires OpenGL).
 .
 An extensive debugger is included, with the Distella disassembler.
 .
 Note that this is not isee systems' STELLA modeling, simulation and
 analysis tool.

## stella 4.0

=== debian/changelog ===
stella (4.0-2) unstable; urgency=medium

  * Support newer versions of Hurd.

 -- Stephen Kitt <skitt@debian.org>  Wed, 02 Jul 2014 07:07:41 +0200

stella (4.0-1) unstable; urgency=medium

  * New upstream version.

 -- Stephen Kitt <skitt@debian.org>  Tue, 01 Jul 2014 23:30:31 +0200

## stella 4.1.1

=== debian/changelog ===
stella (4.1.1-1) unstable; urgency=medium

  * New upstream version.
  * Update licensing information.

 -- Stephen Kitt <skitt@debian.org>  Mon, 15 Sep 2014 23:44:54 +0200

stella (4.1-1) unstable; urgency=medium

  * New upstream version.
  * Drop hurd-gnu0.5.patch, merged upstream.

 -- Stephen Kitt <skitt@debian.org>  Wed, 03 Sep 2014 09:11:33 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: autotools-dev,
                debhelper (>= 9),
                libpng-dev,
-               libsdl1.2-dev,
+               libsdl2-dev,
                zlib1g-dev
 Homepage: http://stella.sf.net
 Vcs-Git: git://anonscm.debian.org/pkg-games/stella.git

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autotools_dev

override_dh_auto_clean:
# Generate the minimal config.mak required for "make distclean"
	test -f config.mak || echo "RM_REC := rm -f -r" > config.mak
	dh_auto_clean

override_dh_clean:
	dh_clean tags

override_dh_auto_configure:
	./configure --prefix=/usr

override_dh_auto_install:
	dh_auto_install
	# This is also installed as the upstream changelog
	rm $(CURDIR)/debian/stella/usr/share/doc/stella/Changes.txt
	# This is overridden by the copyright file
	rm $(CURDIR)/debian/stella/usr/share/doc/stella/License.txt

## stella 4.6.1

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 ##  SS  SS   tt   ee      ll   ll  aa  aa
 ##   SSSS     ttt  eeeee llll llll  aaaaa
 ##
-## Copyright (c) 1995-2014 by Bradford W. Mott, Stephen Anthony
+## Copyright (c) 1995-2015 by Bradford W. Mott, Stephen Anthony
 ## and the Stella Team
 ##
 ## See the file "License.txt" for information on usage and redistribution of
@@ -51,7 +51,7 @@
 endif
 CXXFLAGS+= -Wall 
 ifdef HAVE_GCC
-  CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual
+  CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++11
 endif
 
 ifdef PROFILE
@@ -213,8 +213,8 @@
 src/emucore/M6502.ins: src/emucore/M6502.m4
 	m4 src/emucore/M6502.m4 > src/emucore/M6502.ins
 
-# Special rule for Win32 icon stuff (there's probably a better way to do this ...)
-src/win32/stella_icon.o: src/win32/stella.ico src/win32/stella.rc
-	$(WINDRES) --include-dir src/win32 src/win32/stella.rc src/win32/stella_icon.o 
+# Special rule for windows icon stuff (there's probably a better way to do this ...)
+src/windows/stella_icon.o: src/windows/stella.ico src/windows/stella.rc
+	windres --include-dir src/windows src/windows/stella.rc src/windows/stella_icon.o 
 		
 .PHONY: deb bundle test install uninstall

=== debian/changelog ===
stella (4.6.1-2) unstable; urgency=medium

  * Add an icon for the menu entry (closes: #726888).
  * Upload to unstable.

 -- Stephen Kitt <skitt@debian.org>  Sun, 10 May 2015 22:50:25 +0200

stella (4.6.1-1) experimental; urgency=medium

  * New upstream version.

 -- Stephen Kitt <skitt@debian.org>  Fri, 24 Apr 2015 20:45:00 +0200

stella (4.6-1) experimental; urgency=medium

  * New upstream version.
  * Drop src/common/SharedPtr.hxx from debian/copyright, it no longer
    exists.
  * Standards-Version 3.9.6, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 21 Mar 2015 22:45:21 +0100

stella (4.5-1) experimental; urgency=medium

  * New upstream version.

 -- Stephen Kitt <skitt@debian.org>  Thu, 01 Jan 2015 23:57:10 +0100

stella (4.2-1) experimental; urgency=medium

  * New upstream version, uploaded to experimental for the Jessie freeze.

 -- Stephen Kitt <skitt@debian.org>  Mon, 03 Nov 2014 00:16:42 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Stephen Kitt <skitt@debian.org>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Build-Depends: autotools-dev,
                debhelper (>= 9),
+               g++ (>= 4:4.9),
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
@@ -16,7 +17,8 @@
 Package: stella
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Description: Atari 2600 Emulator for SDL & the X Window System
  Stella is a portable emulator of the old Atari 2600 video-game
  console. You can play most Atari 2600 games with it.

## stella 4.6.6

=== debian/changelog ===
stella (4.6.6-1) unstable; urgency=medium

  * New upstream version.
  * Drop Debian menu.

 -- Stephen Kitt <skitt@debian.org>  Mon, 12 Oct 2015 19:16:57 +0200

stella (4.6.5-1) unstable; urgency=medium

  * New upstream version.

 -- Stephen Kitt <skitt@debian.org>  Tue, 29 Sep 2015 18:10:48 +0200

## stella 4.7

=== debian/changelog ===
stella (4.7-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Stephen Kitt <skitt@debian.org>  Tue, 09 Feb 2016 13:11:38 +0100

stella (4.7-1) unstable; urgency=medium

  * New upstream version.
  * Switch to https: VCS URIs (see #810378).
  * Fix the spelling of "Commmands" and ignore "Flie".

 -- Stephen Kitt <skitt@debian.org>  Tue, 26 Jan 2016 12:54:57 +0100

stella (4.6.7-1) unstable; urgency=medium

  * New upstream version.

 -- Stephen Kitt <skitt@debian.org>  Wed, 28 Oct 2015 23:25:35 +0100

## stella 4.7.1

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 ##  SS  SS   tt   ee      ll   ll  aa  aa
 ##   SSSS     ttt  eeeee llll llll  aaaaa
 ##
-## Copyright (c) 1995-2015 by Bradford W. Mott, Stephen Anthony
+## Copyright (c) 1995-2016 by Bradford W. Mott, Stephen Anthony
 ## and the Stella Team
 ##
 ## See the file "License.txt" for information on usage and redistribution of
@@ -49,7 +49,7 @@
 else
   CXXFLAGS:= -O2
 endif
-CXXFLAGS+= -Wall 
+CXXFLAGS+= -Wall -Wextra -Wno-unused-parameter -Wno-ignored-qualifiers
 ifdef HAVE_GCC
   CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++11
 endif

=== debian/changelog ===
stella (4.7.1-1) unstable; urgency=medium

  * New upstream version.
  * Make debian/watch more generic.
  * Install evdev-joystick and Stelladaptor and 2600-daptor udev rules.

 -- Stephen Kitt <skitt@debian.org>  Mon, 15 Feb 2016 17:46:57 +0100

=== debian/control ===
--- 
+++ 
@@ -11,8 +11,8 @@
                libsdl2-dev,
                zlib1g-dev
 Homepage: http://stella.sf.net
-Vcs-Git: git://anonscm.debian.org/pkg-games/stella.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/stella.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-games/stella.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/stella.git
 
 Package: stella
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -8,11 +8,13 @@
 	test -f config.mak || echo "RM_REC := rm -f -r" > config.mak
 	dh_auto_clean
 
-override_dh_clean:
-	dh_clean tags
-
 override_dh_auto_configure:
 	./configure --prefix=/usr
+
+override_dh_auto_build:
+	dh_auto_build
+	dh_auto_build -B src/tools/evdev-joystick
+	sed 'sXlocal/XXg' < src/tools/evdev-joystick/80-stelladaptor-joystick.rules > debian/stella.udev
 
 override_dh_auto_install:
 	dh_auto_install

=== debian/watch ===
version=3
http://sf.net/@PACKAGE@/@PACKAGE@@ANY_VERSION@-src@ARCHIVE_EXT@

## stella 4.7.2

=== debian/changelog ===
stella (4.7.2-1) unstable; urgency=medium

  * New upstream version.
  * Rely on joystick to provide evdev-joystick and the associated udev
    rules.
  * Enable all hardening options.
  * Clean up debian/control using cme.
  * Standards-Version 3.9.8, no change required.

 -- Stephen Kitt <skitt@debian.org>  Tue, 19 Apr 2016 23:56:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,25 @@
 Source: stella
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Uploaders: Stephen Kitt <skitt@debian.org>
 Section: otherosfs
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Stephen Kitt <skitt@debian.org>
-Standards-Version: 3.9.6
 Build-Depends: autotools-dev,
                debhelper (>= 9),
                g++ (>= 4:4.9),
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
+Standards-Version: 3.9.8
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/stella.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-games/stella.git
 Homepage: http://stella.sf.net
-Vcs-Git: https://anonscm.debian.org/git/pkg-games/stella.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/stella.git
 
 Package: stella
 Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Recommends: joystick (>= 1:1.5.1)
+Pre-Depends: ${misc:Pre-Depends}
 Description: Atari 2600 Emulator for SDL & the X Window System
  Stella is a portable emulator of the old Atari 2600 video-game
  console. You can play most Atari 2600 games with it.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
 	dh $@ --with autotools_dev
@@ -11,11 +13,6 @@
 override_dh_auto_configure:
 	./configure --prefix=/usr
 
-override_dh_auto_build:
-	dh_auto_build
-	dh_auto_build -B src/tools/evdev-joystick
-	sed 'sXlocal/XXg' < src/tools/evdev-joystick/80-stelladaptor-joystick.rules > debian/stella.udev
-
 override_dh_auto_install:
 	dh_auto_install
 	# This is also installed as the upstream changelog

## stella 4.7.3

=== Makefile ===
--- 
+++ 
@@ -26,7 +26,7 @@
 
 srcdir      ?= .
 
-DEFINES     :=
+DEFINES     := -D_GLIBCXX_USE_CXX11_ABI=1
 LDFLAGS     :=
 INCLUDES    :=
 LIBS	    :=

=== debian/changelog ===
stella (4.7.3-1~bpo8+1) jessie-backports; urgency=medium

  * Backport to Debian 8.

 -- Stephen Kitt <skitt@debian.org>  Tue, 06 Jun 2017 08:59:46 +0200

stella (4.7.3-1) unstable; urgency=medium

  * New upstream version.
  * Update spelling fixes.
  * Switch to debhelper compatibility level 10.

 -- Stephen Kitt <skitt@debian.org>  Thu, 24 Nov 2016 23:06:44 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,7 @@
 Uploaders: Stephen Kitt <skitt@debian.org>
 Section: otherosfs
 Priority: optional
-Build-Depends: autotools-dev,
-               debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                g++ (>= 4:4.9),
                libpng-dev,
                libsdl2-dev,

## stella 5.0.1

=== Makefile ===
--- 
+++ 
@@ -45,13 +45,13 @@
 # CXXFLAGS+= -Werror
 
 ifdef CXXFLAGS
-  CXXFLAGS:= $(CXXFLAGS)
+  CXXFLAGS:= $(CXXFLAGS) -x c++
 else
-  CXXFLAGS:= -O2
+  CXXFLAGS:= -O2 -x c++
 endif
 CXXFLAGS+= -Wall -Wextra -Wno-unused-parameter -Wno-ignored-qualifiers
 ifdef HAVE_GCC
-  CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++11
+  CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++14
 endif
 
 ifdef PROFILE
@@ -66,7 +66,7 @@
 # Even more warnings...
 #CXXFLAGS+= -pedantic -Wpointer-arith -Wcast-qual -Wconversion
 #CXXFLAGS+= -Wshadow -Wimplicit -Wundef -Wnon-virtual-dtor
-#CXXFLAGS+= -Wno-reorder -Wwrite-strings -fcheck-new -Wctor-dtor-privacy 
+#CXXFLAGS+= -Wno-reorder -Wwrite-strings -fcheck-new -Wctor-dtor-privacy
 
 #######################################################################
 # Misc stuff - you should never have to edit this                     #
@@ -94,6 +94,7 @@
 # After the game specific modules follow the shared modules
 MODULES += \
 	src/emucore \
+	src/emucore/tia \
 	src/gui \
 	src/common \
 	src/common/tv_filters
@@ -111,7 +112,7 @@
 
 # Depdir information
 DEPDIRS = $(addsuffix /$(DEPDIR),$(MODULE_DIRS))
-DEPFILES = 
+DEPFILES =
 
 # The build rule for the Stella executable
 $(EXECUTABLE):  $(OBJS)
@@ -131,7 +132,7 @@
 
 ifndef CXX_UPDATE_DEP_FLAG
 # If you use GCC, disable the above and enable this for intelligent
-# dependency tracking. 
+# dependency tracking.
 CXX_UPDATE_DEP_FLAG = -Wp,-MMD,"$(*D)/$(DEPDIR)/$(*F).d2"
 .cxx.o:
 	$(MKDIR) $(*D)/$(DEPDIR)
@@ -215,6 +216,6 @@
 
 # Special rule for windows icon stuff (there's probably a better way to do this ...)
 src/windows/stella_icon.o: src/windows/stella.ico src/windows/stella.rc
-	windres --include-dir src/windows src/windows/stella.rc src/windows/stella_icon.o 
-		
+	windres --include-dir src/windows src/windows/stella.rc src/windows/stella_icon.o
+
 .PHONY: deb bundle test install uninstall

=== debian/changelog ===
stella (5.0.1-1) unstable; urgency=medium

  * New upstream release, compatible with GCC 7 (closes: #853669).
  * Update the upstream homepage, the project has moved from SourceForge
    to GitHub.
  * Standards-Version 4.0.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 05 Aug 2017 23:31:21 +0200

=== debian/control ===
--- 
+++ 
@@ -8,10 +8,10 @@
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/stella.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/stella.git
-Homepage: http://stella.sf.net
+Homepage: https://stella-emu.github.io
 
 Package: stella
 Architecture: any

## stella 5.0.2

=== Makefile ===
--- 
+++ 
@@ -27,7 +27,7 @@
 srcdir      ?= .
 
 DEFINES     := -D_GLIBCXX_USE_CXX11_ABI=1
-LDFLAGS     :=
+LDFLAGS     := -pthread
 INCLUDES    :=
 LIBS	    :=
 OBJS	    :=

=== debian/changelog ===
stella (5.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Mon, 21 Aug 2017 09:17:25 +0200

## stella 5.1

=== debian/changelog ===
stella (5.1-1) unstable; urgency=medium

  * New upstream release, merging spelling-fixes.patch.
  * Switch to debhelper compatibility level 11.
  * Standards-Version 4.1.3, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 05 Feb 2018 22:26:21 +0100

## stella 5.1.1

=== Makefile ===
--- 
+++ 
@@ -53,6 +53,13 @@
 ifdef HAVE_GCC
   CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++14
 endif
+ifdef CLANG_WARNINGS
+  CXXFLAGS+= -Weverything -Wno-c++17-extensions -Wno-c++98-compat -Wno-c++98-compat-pedantic \
+    -Wno-double-promotion -Wno-switch-enum -Wno-conversion -Wno-covered-switch-default \
+    -Wno-inconsistent-missing-destructor-override -Wno-float-equal \
+    -Wno-exit-time-destructors -Wno-global-constructors -Wno-weak-vtables \
+    -Wno-four-char-constants -Wno-padded
+endif
 
 ifdef PROFILE
   PROF:= -g -pg -fprofile-arcs -ftest-coverage
@@ -63,10 +70,6 @@
   endif
 endif
 
-# Even more warnings...
-#CXXFLAGS+= -pedantic -Wpointer-arith -Wcast-qual -Wconversion
-#CXXFLAGS+= -Wshadow -Wimplicit -Wundef -Wnon-virtual-dtor
-#CXXFLAGS+= -Wno-reorder -Wwrite-strings -fcheck-new -Wctor-dtor-privacy
 
 #######################################################################
 # Misc stuff - you should never have to edit this                     #
@@ -95,6 +98,7 @@
 MODULES += \
 	src/emucore \
 	src/emucore/tia \
+	src/emucore/tia/frame-manager \
 	src/gui \
 	src/common \
 	src/common/tv_filters

=== debian/changelog ===
stella (5.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Fri, 23 Feb 2018 20:50:30 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Uploaders: Stephen Kitt <skitt@debian.org>
 Section: otherosfs
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11~),
                g++ (>= 4:4.9),
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
-Standards-Version: 4.0.0
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/stella.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/stella.git
 Homepage: https://stella-emu.github.io

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --with autotools_dev
+	dh $@
 
 override_dh_auto_clean:
 # Generate the minimal config.mak required for "make distclean"

## stella 5.1.2

=== debian/changelog ===
stella (5.1.2-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sun, 20 May 2018 21:10:04 +0200

stella (5.1.1-2) unstable; urgency=medium

  * Migrate to Salsa.
  * Standards-Version 4.1.4, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Thu, 17 May 2018 01:01:43 +0200

## stella 5.1.3

=== Makefile ===
--- 
+++ 
@@ -147,7 +147,7 @@
 
 .c.o:
 	$(MKDIR) $(*D)/$(DEPDIR)
-	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
 	$(ECHO) "$(*D)/" > $(*D)/$(DEPDIR)/$(*F).d
 	$(CAT) "$(*D)/$(DEPDIR)/$(*F).d2" >> "$(*D)/$(DEPDIR)/$(*F).d"
 	$(RM) "$(*D)/$(DEPDIR)/$(*F).d2"
@@ -162,7 +162,7 @@
 
 .c.o:
 	$(MKDIR) $(*D)/$(DEPDIR)
-	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
 endif
 
 # Include the dependency tracking files. We add /dev/null at the end

=== debian/changelog ===
stella (5.1.3-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Thu, 14 Jun 2018 11:04:11 +0200

=== debian/control ===
--- 
+++ 
@@ -8,9 +8,9 @@
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/stella.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-games/stella.git
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/games-team/stella
+Vcs-Git: https://salsa.debian.org/games-team/stella.git
 Homepage: https://stella-emu.github.io
 
 Package: stella

## stella 6.0

=== debian/changelog ===
stella (6.0-1) unstable; urgency=medium

  * New upstream release.
  * Set “Rules-Requires-Root: no”.
  * Standards-Version 4.3.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 12 Jan 2019 21:56:40 +0100

=== debian/control ===
--- 
+++ 
@@ -8,10 +8,11 @@
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/games-team/stella
 Vcs-Git: https://salsa.debian.org/games-team/stella.git
 Homepage: https://stella-emu.github.io
+Rules-Requires-Root: no
 
 Package: stella
 Architecture: any

## stella 6.0.1

=== debian/changelog ===
stella (6.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Switch to debhelper compatibility level 12 (and stop stripping the
    stella binary during the build).
  * Standards-Version 4.4.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Tue, 16 Jul 2019 18:11:40 +0200

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Uploaders: Stephen Kitt <skitt@debian.org>
 Section: otherosfs
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                g++ (>= 4:4.9),
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/games-team/stella
 Vcs-Git: https://salsa.debian.org/games-team/stella.git
 Homepage: https://stella-emu.github.io

## stella 6.0.2

=== Makefile ===
--- 
+++ 
@@ -101,7 +101,8 @@
 	src/emucore/tia/frame-manager \
 	src/gui \
 	src/common \
-	src/common/tv_filters
+	src/common/tv_filters \
+	src/common/audio
 
 ######################################################################
 # The build rules follow - normally you should have no need to

=== src/tools/evdev-joystick/Makefile ===
all : evdev-joystick

evdev-joystick: evdev-joystick.c
	gcc -Wall -O2 -o evdev-joystick evdev-joystick.c

install: evdev-joystick 80-stelladaptor-joystick.rules
	install -s evdev-joystick /usr/local/bin/
	install -m 644 80-stelladaptor-joystick.rules /etc/udev/rules.d/

clean:
	rm -rf evdev-joystick

=== debian/changelog ===
stella (6.0.2-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:58:51 +0100

stella (6.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop the g++ build dependency, it’s redundant and prevents cross-
    building.
  * Standards-Version 4.4.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 12 Oct 2019 22:03:54 +0200

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,10 @@
 Section: otherosfs
 Priority: optional
 Build-Depends: debhelper-compat (= 12),
-               g++ (>= 4:4.9),
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/games-team/stella
 Vcs-Git: https://salsa.debian.org/games-team/stella.git
 Homepage: https://stella-emu.github.io

## stella 6.1.2

=== Makefile ===
--- 
+++ 
@@ -14,8 +14,6 @@
 ## See the file "License.txt" for information on usage and redistribution of
 ## this file, and for a DISCLAIMER OF ALL WARRANTIES.
 ##
-## $Id: Makefile,v 1.37 2009-01-11 21:31:21 stephena Exp $
-##
 ##   Based on code from ScummVM - Scumm Interpreter
 ##   Copyright (C) 2002-2004 The ScummVM project
 ##============================================================================
@@ -26,7 +24,7 @@
 
 srcdir      ?= .
 
-DEFINES     := -D_GLIBCXX_USE_CXX11_ABI=1
+DEFINES     := -DSDL_SUPPORT -D_GLIBCXX_USE_CXX11_ABI=1
 LDFLAGS     := -pthread
 INCLUDES    :=
 LIBS	    :=
@@ -49,36 +47,90 @@
 else
   CXXFLAGS:= -O2 -x c++
 endif
-CXXFLAGS+= -Wall -Wextra -Wno-unused-parameter -Wno-ignored-qualifiers
+
+CXXFLAGS+= -Wall -Wextra -Wno-unused-parameter
+
 ifdef HAVE_GCC
   CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++14
 endif
+
+ifdef HAVE_CLANG
+  CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++14
+endif
+
 ifdef CLANG_WARNINGS
-  CXXFLAGS+= -Weverything -Wno-c++17-extensions -Wno-c++98-compat -Wno-c++98-compat-pedantic \
-    -Wno-double-promotion -Wno-switch-enum -Wno-conversion -Wno-covered-switch-default \
+  CXXFLAGS+= -Weverything -Wno-c++17-extensions  -Wno-c++98-compat-pedantic \
+    -Wno-switch-enum -Wno-conversion -Wno-covered-switch-default \
     -Wno-inconsistent-missing-destructor-override -Wno-float-equal \
     -Wno-exit-time-destructors -Wno-global-constructors -Wno-weak-vtables \
     -Wno-four-char-constants -Wno-padded
 endif
 
 ifdef PROFILE
-  PROF:= -g -pg -fprofile-arcs -ftest-coverage
+  PROF:= -pg -fprofile-arcs -ftest-coverage
   CXXFLAGS+= $(PROF)
+endif
+
+ifdef DEBUG
+  CXXFLAGS += -g
 else
   ifdef HAVE_GCC
     CXXFLAGS+= -fomit-frame-pointer
   endif
-endif
-
+
+  ifdef HAVE_CLANG
+    CXXFLAGS+= -fomit-frame-pointer
+  endif
+endif
 
 #######################################################################
 # Misc stuff - you should never have to edit this                     #
 #######################################################################
 
-EXECUTABLE  := stella$(EXEEXT)
+ifdef STELLA_BUILD_ROOT
+  OBJECT_ROOT := $(STELLA_BUILD_ROOT)/stella-out
+else
+  OBJECT_ROOT := out
+endif
+OBJECT_ROOT_PROFILE_GENERERATE := out.pgen
+OBJECT_ROOT_PROFILE_USE := out.pgo
+
+EXECUTABLE := stella$(EXEEXT)
+EXECUTABLE_PROFILE_GENERATE := stella-pgo-generate$(EXEEXT)
+EXECUTABLE_PROFILE_USE := stella-pgo$(EXEEXT)
+
+PROFILE_DIR = $(CURDIR)/profile
+PROFILE_OUT = $(PROFILE_DIR)/out
+PROFILE_STAMP = profile.stamp
+
+CXXFLAGS_PROFILE_GENERATE = $(CXXFLAGS)
+CXXFLAGS_PROFILE_USE = $(CXXFLAGS)
+LDFLAGS_PROFILE_GENERATE = $(LDFLAGS)
+STELLA_PROFILE_GENERATE = $(BINARY_LOADER) ./$(EXECUTABLE_PROFILE_GENERATE) -profile \
+	$(PROFILE_DIR)/128.bin:10 \
+	$(PROFILE_DIR)/catharsis_theory.bin:60
+
+ifdef HAVE_CLANG
+	CXXFLAGS_PROFILE_GENERATE += -fprofile-generate=$(PROFILE_OUT)
+	CXXFLAGS_PROFILE_USE += -fprofile-use=$(PROFILE_OUT)
+	LDFLAGS_PROFILE_GENERATE += -fprofile-generate
+	STELLA_PROFILE_GENERATE := \
+		LLVM_PROFILE_FILE="$(PROFILE_OUT)/default.profraw" $(STELLA_PROFILE_GENERATE) && \
+		$(LLVM_PROFDATA) merge -o $(PROFILE_OUT)/default.profdata $(PROFILE_OUT)/default.profraw
+endif
+
+ifdef HAVE_GCC
+	CXXFLAGS_PROFILE_GENERATE += -fprofile-generate -fprofile-dir=$(PROFILE_OUT)
+	CXXFLAGS_PROFILE_USE += -fprofile-use -fprofile-dir=$(PROFILE_OUT)
+	LDFLAGS_PROFILE_GENERATE += -fprofile-generate
+	STELLA_PROFILE_GENERATE := $(STELLA_PROFILE_GENERATE) && \
+	  rm -fr $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE) && \
+		mv $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_GENERERATE) $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE)
+endif
 
 all: $(EXECUTABLE)
 
+pgo: $(EXECUTABLE_PROFILE_USE)
 
 ######################################################################
 # Various minor settings
@@ -96,13 +148,12 @@
 
 # After the game specific modules follow the shared modules
 MODULES += \
+	src/common \
+	src/common/audio \
+	src/common/tv_filters \
 	src/emucore \
 	src/emucore/tia \
-	src/emucore/tia/frame-manager \
-	src/gui \
-	src/common \
-	src/common/tv_filters \
-	src/common/audio
+	src/emucore/tia/frame-manager
 
 ######################################################################
 # The build rules follow - normally you should have no need to
@@ -119,8 +170,18 @@
 DEPDIRS = $(addsuffix /$(DEPDIR),$(MODULE_DIRS))
 DEPFILES =
 
+OBJ=$(addprefix $(OBJECT_ROOT)/,$(OBJS))
+OBJ_PROFILE_GENERATE=$(addprefix $(OBJECT_ROOT_PROFILE_GENERERATE)/,$(OBJS))
+OBJ_PROFILE_USE=$(addprefix $(OBJECT_ROOT_PROFILE_USE)/,$(OBJS))
+
 # The build rule for the Stella executable
-$(EXECUTABLE):  $(OBJS)
+$(EXECUTABLE): $(OBJ)
+	$(LD) $(LDFLAGS) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) $(PROF) -o $@
+
+$(EXECUTABLE_PROFILE_GENERATE): $(OBJ_PROFILE_GENERATE)
+	$(LD) $(LDFLAGS_PROFILE_GENERATE) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) $(PROF) -o $@
+
+$(EXECUTABLE_PROFILE_USE): $(OBJ_PROFILE_USE)
 	$(LD) $(LDFLAGS) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) $(PROF) -o $@
 
 distclean: clean
@@ -128,47 +189,100 @@
 	$(RM) build.rules config.h config.mak config.log
 
 clean:
-	$(RM) $(OBJS) $(EXECUTABLE)
+	-$(RM) -fr \
+		$(OBJECT_ROOT) $(OBJECT_ROOT_PROFILE_GENERERATE) $(OBJECT_ROOT_PROFILE_USE) \
+		$(EXECUTABLE) $(EXECUTABLE_PROFILE_GENERATE) $(EXECUTABLE_PROFILE_USE) \
+		$(PROFILE_OUT) $(PROFILE_STAMP)
 
 .PHONY: all clean dist distclean
 
 .SUFFIXES: .cxx
 
+define create_dir
+$(MKDIR) -p $(*D)/$(DEPDIR)
+$(MKDIR) -p $(@D)
+endef
+
+define merge_dep
+$(ECHO) "$(*D)/" > $(*D)/$(DEPDIR)/$(*F).d
+$(CAT) "$(*D)/$(DEPDIR)/$(*F).d2" >> "$(*D)/$(DEPDIR)/$(*F).d"
+$(RM) "$(*D)/$(DEPDIR)/$(*F).d2"
+endef
 
 ifndef CXX_UPDATE_DEP_FLAG
 # If you use GCC, disable the above and enable this for intelligent
 # dependency tracking.
 CXX_UPDATE_DEP_FLAG = -Wp,-MMD,"$(*D)/$(DEPDIR)/$(*F).d2"
-.cxx.o:
-	$(MKDIR) $(*D)/$(DEPDIR)
-	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
-	$(ECHO) "$(*D)/" > $(*D)/$(DEPDIR)/$(*F).d
-	$(CAT) "$(*D)/$(DEPDIR)/$(*F).d2" >> "$(*D)/$(DEPDIR)/$(*F).d"
-	$(RM) "$(*D)/$(DEPDIR)/$(*F).d2"
-
-.c.o:
-	$(MKDIR) $(*D)/$(DEPDIR)
-	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
-	$(ECHO) "$(*D)/" > $(*D)/$(DEPDIR)/$(*F).d
-	$(CAT) "$(*D)/$(DEPDIR)/$(*F).d2" >> "$(*D)/$(DEPDIR)/$(*F).d"
-	$(RM) "$(*D)/$(DEPDIR)/$(*F).d2"
+
+$(OBJECT_ROOT)/%.o: %.cxx
+	$(create_dir)
+	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@
+	$(merge_dep)
+
+$(OBJECT_ROOT)/%.o: %.c
+	$(create_dir)
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@
+	$(merge_dep)
+
+$(OBJECT_ROOT_PROFILE_GENERERATE)/%.pgen.o: %.cxx
+	$(create_dir)
+	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
+	$(merge_dep)
+
+$(OBJECT_ROOT_PROFILE_GENERERATE)/%.pgen.o: %.cxx
+	$(create_dir)
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
+	$(merge_dep)
+
+$(OBJECT_ROOT_PROFILE_USE)/%.pgo.o: %.cxx $(PROFILE_STAMP)
+	$(create_dir)
+	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
+	$(merge_dep)
+
+$(OBJECT_ROOT_PROFILE_USE)/%.pgo.o: %.cxx $(PROFILE_STAMP)
+	$(create_dir)
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
+	$(merge_dep)
+
 else
 # If you even have GCC 3.x, you can use this build rule, which is safer; the above
 # rule can get you into a bad state if you Ctrl-C at the wrong moment.
 # Also, with this GCC inserts additional dummy rules for the involved headers,
 # which ensures a smooth compilation even if said headers become obsolete.
-.cxx.o:
-	$(MKDIR) $(*D)/$(DEPDIR)
-	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
-
-.c.o:
-	$(MKDIR) $(*D)/$(DEPDIR)
-	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $*.o
+$(OBJECT_ROOT)/%.o: %.cxx
+	$(create_dir)
+	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@
+
+$(OBJECT_ROOT)/%.o: %.c
+	$(create_dir)
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@
+
+$(OBJECT_ROOT_PROFILE_GENERERATE)/%.o: %.cxx
+	$(create_dir)
+	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
+
+$(OBJECT_ROOT_PROFILE_GENERERATE)/%.o: %.c
+	$(create_dir)
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
+
+$(OBJECT_ROOT_PROFILE_USE)/%.o: %.cxx $(PROFILE_STAMP)
+	$(create_dir)
+	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
+
+$(OBJECT_ROOT_PROFILE_USE)/%.o: %.c $(PROFILE_STAMP)
+	$(create_dir)
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
+
 endif
 
 # Include the dependency tracking files. We add /dev/null at the end
 # of the list to avoid a warning/error if no .d file exist
 -include $(wildcard $(addsuffix /*.d,$(DEPDIRS))) /dev/null
+
+$(PROFILE_STAMP): $(EXECUTABLE_PROFILE_GENERATE)
+	-rm -fr $(PROFILE_OUT)
+	$(STELLA_PROFILE_GENERATE)
+	touch $(PROFILE_STAMP)
 
 # check if configure has been run or has been changed since last run
 config.mak: $(srcdir)/configure
@@ -178,7 +292,7 @@
 
 install: all
 	$(INSTALL) -d "$(DESTDIR)$(BINDIR)"
-	$(INSTALL) -c -s -m 755 "$(srcdir)/stella$(EXEEXT)" "$(DESTDIR)$(BINDIR)/stella$(EXEEXT)"
+	$(INSTALL) -c -m 755 "$(srcdir)/stella$(EXEEXT)" "$(DESTDIR)$(BINDIR)/stella$(EXEEXT)"
 	$(INSTALL) -d "$(DESTDIR)$(DOCDIR)"
 	$(INSTALL) -c -m 644 "$(srcdir)/Announce.txt" "$(srcdir)/Changes.txt" "$(srcdir)/Copyright.txt" "$(srcdir)/License.txt" "$(srcdir)/README-SDL.txt" "$(srcdir)/Readme.txt" "$(srcdir)/Todo.txt" "$(srcdir)/docs/index.html" "$(srcdir)/docs/debugger.html" "$(DESTDIR)$(DOCDIR)/"
 	$(INSTALL) -d "$(DESTDIR)$(DOCDIR)/graphics"
@@ -215,12 +329,3 @@
 	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/64x64/apps/stella.png"
 	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps/stella.png"
 
-# Special rule for M6502.ins, generated from m4 (there's probably a better way to do this ...)
-src/emucore/M6502.ins: src/emucore/M6502.m4
-	m4 src/emucore/M6502.m4 > src/emucore/M6502.ins
-
-# Special rule for windows icon stuff (there's probably a better way to do this ...)
-src/windows/stella_icon.o: src/windows/stella.ico src/windows/stella.rc
-	windres --include-dir src/windows src/windows/stella.rc src/windows/stella_icon.o
-
-.PHONY: deb bundle test install uninstall

=== debian/changelog ===
stella (6.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.5.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 23 May 2020 19:36:27 +0200
